Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.poi.util
Class IntList

    java.lang.Object
      org.apache.poi.util.IntList

    public class IntList

extends java.lang.Object

A List of int's; as full an implementation of the java.util.List interface as possible, with an eye toward minimal creation of objects the mimicry of List is as follows:

- if possible, operations designated 'optional' in the List interface are attempted
- wherever the List interface refers to an Object, substitute int
- wherever the List interface refers to a Collection or List, substitute IntList

the mimicry is not perfect, however:

- operations involving Iterators or ListIterators are not supported
- remove(Object) becomes removeValue to distinguish it from remove(int index)
- subList is not supported

Author:
  Marc Johnson

Constructor Summary
`IntList()` create an IntList of default size
`IntList(int initialCapacity)`
`IntList(int initialCapacity, int fillvalue)` create an IntList with a predefined initial size
`IntList(IntList list)` create a copy of an existing IntList

Method Summary
`boolean` | `add(int value)` Appends the specified element to the end of this list
`void` | `add(int index, int value)` add the specfied value at the specified index
`boolean` | `addAll(int index, IntList c)` Inserts all of the elements in the specified collection into this list at the specified position.
`boolean` | `addAll(IntList c)` Appends all of the elements in the specified collection to the end of this list, in the order that they are returned by the specified collection's iterator.
`void` | `clear()` Removes all of the elements from this list.
`boolean` | `contains(int o)` Returns true if this list contains the specified element.
`boolean` | `containsAll(IntList c)` Returns true if this list contains all of the elements of the specified collection.
`boolean` | `equals(java.lang.Object o)` Compares the specified object with this list for equality.
`int` | `get(int index)` Returns the element at the specified position in this list.
`int` | `hashCode()` Returns the hash code value for this list.
`int` | `indexOf(int o)` Returns the index in this list of the first occurrence of the specified element, or -1 if this list does not contain this element.
`boolean` | `isEmpty()` Returns true if this list contains no elements.
`int` | `lastIndexOf(int o)` Returns the index in this list of the last occurrence of the specified element, or -1 if this list does not contain this element.
`int` | `remove(int index)` Removes the element at the specified position in this list.
`boolean` | `removeAll(IntList c)` Removes from this list all the elements that are contained in the specified collection
`boolean` | `removeValue(int o)` Removes the first occurrence in this list of the specified element (optional operation).
`boolean` | `retainAll(IntList c)` Retains only the elements in this list that are contained in the specified collection.
`int` | `set(int index, int element)` Replaces the element at the specified position in this list with the specified element
`int` | `size()` Returns the number of elements in this list.
`int[]` | `toArray()` Returns an array containing all of the elements in this list in proper sequence.
`int[]` | `toArray(int[] a)` Returns an array containing all of the elements in this list in proper sequence.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### IntList

    public IntList()

  create an IntList of default size

### IntList

    public IntList(int initialCapacity)

### IntList

    public IntList(IntList list)

  create a copy of an existing IntList

  Parameters:
    `list` - the existing IntList

### IntList

    public IntList(int initialCapacity,
                   int fillvalue)

  create an IntList with a predefined initial size

  Parameters:
    `initialCapacity` - the size for the internal array

Method Detail

### add

    public void add(int index,
                    int value)

  add the specfied value at the specified index

  Parameters:
    `index` - the index where the new value is to be added
    `value` - the new value
  Throws:
    `java.lang.IndexOutOfBoundsException` - if the index is out of range (index < 0 || index > size()).

### add

    public boolean add(int value)

  Appends the specified element to the end of this list

  Parameters:
    `value` - element to be appended to this list.
  Returns:
    true (as per the general contract of the Collection.add method).

### addAll

    public boolean addAll(IntList c)

  Appends all of the elements in the specified collection to the end of this list, in the order that they are returned by the specified collection's iterator. The behavior of this operation is unspecified if the specified collection is modified while the operation is in progress. (Note that this will occur if the specified collection is this list, and it's nonempty.)

  Parameters:
    `c` - collection whose elements are to be added to this list.
  Returns:
    true if this list changed as a result of the call.

### addAll

    public boolean addAll(int index,
                          IntList c)

  Inserts all of the elements in the specified collection into this list at the specified position. Shifts the element currently at that position (if any) and any subsequent elements to the right (increases their indices). The new elements will appear in this list in the order that they are returned by the specified collection's iterator. The behavior of this operation is unspecified if the specified collection is modified while the operation is in progress. (Note that this will occur if the specified collection is this list, and it's nonempty.)

  Parameters:
    `index` - index at which to insert first element from the specified collection.
    `c` - elements to be inserted into this list.
  Returns:
    true if this list changed as a result of the call.
  Throws:
    `java.lang.IndexOutOfBoundsException` - if the index is out of range (index < 0 || index > size())

### clear

    public void clear()

  Removes all of the elements from this list. This list will be empty after this call returns (unless it throws an exception).

### contains

    public boolean contains(int o)

  Returns true if this list contains the specified element. More formally, returns true if and only if this list contains at least one element e such that o == e

  Parameters:
    `o` - element whose presence in this list is to be tested.
  Returns:
    true if this list contains the specified element.

### containsAll

    public boolean containsAll(IntList c)

  Returns true if this list contains all of the elements of the specified collection.

  Parameters:
    `c` - collection to be checked for containment in this list.
  Returns:
    true if this list contains all of the elements of the specified collection.

### equals

    public boolean equals(java.lang.Object o)

  Compares the specified object with this list for equality. Returns true if and only if the specified object is also a list, both lists have the same size, and all corresponding pairs of elements in the two lists are equal. (Two elements e1 and e2 are equal if e1 == e2.) In other words, two lists are defined to be equal if they contain the same elements in the same order. This definition ensures that the equals method works properly across different implementations of the List interface.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `o` - the object to be compared for equality with this list.
  Returns:
    true if the specified object is equal to this list.

### get

    public int get(int index)

  Returns the element at the specified position in this list.

  Parameters:
    `index` - index of element to return.
  Returns:
    the element at the specified position in this list.
  Throws:
    `java.lang.IndexOutOfBoundsException` - if the index is out of range (index < 0 || index >= size()).

### hashCode

    public int hashCode()

  Returns the hash code value for this list. The hash code of a list is defined to be the result of the following calculation: `hashCode = 1; Iterator i = list.iterator(); while (i.hasNext()) { Object obj = i.next(); hashCode = 31*hashCode + (obj==null ? 0 : obj.hashCode()); }` This ensures that list1.equals(list2) implies that list1.hashCode()==list2.hashCode() for any two lists, list1 and list2, as required by the general contract of Object.hashCode.

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    the hash code value for this list.

### indexOf

    public int indexOf(int o)

  Returns the index in this list of the first occurrence of the specified element, or -1 if this list does not contain this element. More formally, returns the lowest index i such that (o == get(i)), or -1 if there is no such index.

  Parameters:
    `o` - element to search for.
  Returns:
    the index in this list of the first occurrence of the specified element, or -1 if this list does not contain this element.

### isEmpty

    public boolean isEmpty()

  Returns true if this list contains no elements.

  Returns:
    true if this list contains no elements.

### lastIndexOf

    public int lastIndexOf(int o)

  Returns the index in this list of the last occurrence of the specified element, or -1 if this list does not contain this element. More formally, returns the highest index i such that (o == get(i)), or -1 if there is no such index.

  Parameters:
    `o` - element to search for.
  Returns:
    the index in this list of the last occurrence of the specified element, or -1 if this list does not contain this element.

### remove

    public int remove(int index)

  Removes the element at the specified position in this list. Shifts any subsequent elements to the left (subtracts one from their indices). Returns the element that was removed from the list.

  Parameters:
    `index` - the index of the element to removed.
  Returns:
    the element previously at the specified position.
  Throws:
    `java.lang.IndexOutOfBoundsException` - if the index is out of range (index < 0 || index >= size()).

### removeValue

    public boolean removeValue(int o)

  Removes the first occurrence in this list of the specified element (optional operation). If this list does not contain the element, it is unchanged. More formally, removes the element with the lowest index i such that (o.equals(get(i))) (if such an element exists).

  Parameters:
    `o` - element to be removed from this list, if present.
  Returns:
    true if this list contained the specified element.

### removeAll

    public boolean removeAll(IntList c)

  Removes from this list all the elements that are contained in the specified collection

  Parameters:
    `c` - collection that defines which elements will be removed from this list.
  Returns:
    true if this list changed as a result of the call.

### retainAll

    public boolean retainAll(IntList c)

  Retains only the elements in this list that are contained in the specified collection. In other words, removes from this list all the elements that are not contained in the specified collection.

  Parameters:
    `c` - collection that defines which elements this set will retain.
  Returns:
    true if this list changed as a result of the call.

### set

    public int set(int index,
                   int element)

  Replaces the element at the specified position in this list with the specified element

  Parameters:
    `index` - index of element to replace.
    `element` - element to be stored at the specified position.
  Returns:
    the element previously at the specified position.
  Throws:
    `java.lang.IndexOutOfBoundsException` - if the index is out of range (index < 0 || index >= size()).

### size

    public int size()

  Returns the number of elements in this list. If this list contains more than Integer.MAX_VALUE elements, returns Integer.MAX_VALUE.

  Returns:
    the number of elements in this IntList

### toArray

    public int[] toArray()

  Returns an array containing all of the elements in this list in proper sequence. Obeys the general contract of the Collection.toArray method.

  Returns:
    an array containing all of the elements in this list in proper sequence.

### toArray

    public int[] toArray(int[] a)

  Returns an array containing all of the elements in this list in proper sequence. Obeys the general contract of the Collection.toArray(Object[]) method.

  Parameters:
    `a` - the array into which the elements of this list are to be stored, if it is big enough; otherwise, a new array is allocated for this purpose.
  Returns:
    an array containing the elements of this list.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 2010 The Apache Software Foundation or its licensors, as applicable.